/*
    <one line to give the library's name and an idea of what it does.>
    Copyright (C) <year>  <name of author>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

*/

#ifndef PREVIEWIMAGEUPDATER_H
#define PREVIEWIMAGEUPDATER_H

extern "C"
{
    #include <sane/sane.h>
}

class QImage;

namespace LibQSane {

class PreviewImageUpdater
{
public:
    PreviewImageUpdater(QImage* img);
    
    void start(const SANE_Parameters& params);
    void beginFrame(const SANE_Parameters& params);
    bool update(const SANE_Byte readData[], int readBytes);
    
private:
    QImage *m_img;
    SANE_Parameters m_params;
    
    int m_frameRead;
    
    int m_pixel_x;
    int m_pixel_y;
    int m_px_c_index;
    int m_px_colors[3];
};

}

#endif // PREVIEWIMAGEUPDATER_H
