#ifndef SANE_DEVICE_DIALOG_P_H
#define SANE_DEVICE_DIALOG_P_H

#include "sane_device_dialog.h"

#include <QMap>

#include "sane_device_info.h"

class QGroupBox;
class QButtonGroup;
class QVBoxLayout;
class QDialogButtonBox;
class QPushButton;

namespace LibQSane
{

class FindSaneDevicesThread;

class SaneDeviceDialogPrivate
{
    Q_DECLARE_PUBLIC(SaneDeviceDialog);
public:
    SaneDeviceDialog* q_ptr;

    SaneDeviceDialogPrivate();
    virtual ~SaneDeviceDialogPrivate();

    void init();

    QWidget                *m_btnContainer;
    QGroupBox              *m_btnBox;
    QButtonGroup           *m_btnGroup;
    QVBoxLayout            *m_btnLayout;
    QDialogButtonBox       *m_buttonBox;
    QPushButton            *m_reloadButton;
    QString                 m_defaultBackend;
    QString                 m_selectedDevice;
    FindSaneDevicesThread  *m_findDevThread;
    bool                    m_autoSelectSingleDevice;
    
    QMap<QString, SaneDeviceInfo> m_deviceInfosMap;

    void _q_setAvailable(bool avail);
    void _q_updateDevicesList();

    bool setDevicesList(const QMap<QString, SaneDeviceInfo>& list);
    //QMap<QString, QString> getDevicesList();
};

}

#endif
