#include "sane_i18n.h"

#include <QCoreApplication>

#include <libintl.h>

namespace LibQSane
{

static const char* hplip_strings[] =
{

QT_TRANSLATE_NOOP("dummy-hplip", "None"),
QT_TRANSLATE_NOOP("dummy-hplip", "MH"),
QT_TRANSLATE_NOOP("dummy-hplip", "MR"),
QT_TRANSLATE_NOOP("dummy-hplip", "MMR"),
QT_TRANSLATE_NOOP("dummy-hplip", "JPEG"),
QT_TRANSLATE_NOOP("dummy-hplip", "Auto"),
QT_TRANSLATE_NOOP("dummy-hplip", "Flatbed"),
QT_TRANSLATE_NOOP("dummy-hplip", "ADF"),
QT_TRANSLATE_NOOP("dummy-hplip", "Advanced"),
QT_TRANSLATE_NOOP("dummy-hplip", "Compression"),
QT_TRANSLATE_NOOP("dummy-hplip", "Selects the scanner compression "\
                  "method for faster scans, possibly at the expense of image quality."),
QT_TRANSLATE_NOOP("dummy-hplip", "JPEG compression factor"),
QT_TRANSLATE_NOOP("dummy-hplip", "Sets the scanner JPEG compression "\
                  "factor. Larger numbers mean better compression, " \
                  "and smaller numbers mean better image quality."),
QT_TRANSLATE_NOOP("dummy-hplip", "Batch scan"),
QT_TRANSLATE_NOOP("dummy-hplip", "Enables continuous scanning with automatic document feeder (ADF)."),
QT_TRANSLATE_NOOP("dummy-hplip", "Duplex"),
QT_TRANSLATE_NOOP("dummy-hplip", "Enables scanning on both sides of the page."),
QT_TRANSLATE_NOOP("dummy-hplip", "Geometry"),
QT_TRANSLATE_NOOP("dummy-hplip", "Length measurement"),
QT_TRANSLATE_NOOP("dummy-hplip", "Selects how the scanned image "\
                  "length is measured and reported, which is impossible to know in advance for scrollfed scans."),
QT_TRANSLATE_NOOP("dummy-hplip", "Unknown"),
QT_TRANSLATE_NOOP("dummy-hplip", "Unlimited"),
QT_TRANSLATE_NOOP("dummy-hplip", "Approximate"),
QT_TRANSLATE_NOOP("dummy-hplip", "Padded"),
QT_TRANSLATE_NOOP("dummy-hplip", "Exact"),
QT_TRANSLATE_NOOP("dummy-hplip", "???")

};

QString sane_i18n(const char* str)
{
    char* translated = dgettext("sane-backends", str);
    if (translated == str)
        return qApp->translate("dummy-hplip", str);
    else
        return QString::fromLocal8Bit(translated);
}

}
